//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

// $Header: fsrename.c,r42 2006-02-18 04:23:47 ingo $


#include "fsyspriv.h"





int FSRename(char *oldname, char *newname)
{
FS_FILE *oldfile,*newfile;
int error;

error=FSInit();
if(error!=FS_OK) return error;

error=FSVolumePresent(FSystem.Volumes[FSystem.CurrentVolume]);
if(error!=FS_OK) { return error; }


error=FSOpen(oldname,FSMODE_READ,&oldfile);
if(error!=FS_OK) return error;




error=FSCreate(newname,oldfile->Attr,&newfile);
if(error!=FS_OK) {
FSClose(oldfile);
return error;
}

if(newfile->Volume!=oldfile->Volume) {
// CANNOT MOVE ACROSS VOLUMES

// TODO: DO A COMPLETE FILE COPY TO ANOTHER VOLUME
FSClose(oldfile);
//error=FSCloseAndDelete(newfile);
FSClose(newfile);
error=FSDelete(newname);

if(error!=FS_OK) return error;
return FS_BADVOLUME;
}



// COPY ALL PROPERTIES

newfile->Attr=oldfile->Attr;
newfile->CrtTmTenth=oldfile->CrtTmTenth;
newfile->LastAccDate=oldfile->LastAccDate;
newfile->CreatTimeDate=oldfile->CreatTimeDate;
newfile->WriteTimeDate=oldfile->WriteTimeDate;
newfile->FirstCluster=oldfile->FirstCluster;
oldfile->FirstCluster=0;
newfile->FileSize=oldfile->FileSize;
oldfile->FileSize=0;

memcpy((void *)&(newfile->Chain),(void *)&(oldfile->Chain),sizeof(FS_FRAGMENT));
memset((void *)&(oldfile->Chain),0,sizeof(FS_FRAGMENT));

memset((void *)&(newfile->RdBuffer),0,sizeof(FS_BUFFER));
memset((void *)&(newfile->WrBuffer),0,sizeof(FS_BUFFER));


error=FSClose(newfile);
if(error!=FS_OK) return error;


//error=FSCloseAndDelete(oldfile);
FSClose(oldfile);
FSDelete(oldname);
return error;

};




