//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>

#include "gglpr.h"


void ggl_hline(gglsurface *srf,int y,int xl,int xr, int color)
{
    // PAINTS A HORIZONTAL LINE FROM xl TO xr BOTH INCLUSIVE
    // color=COLORED PATTERN TO USE, 8 PIXELS - 1 NIBBLE PER PIXEL
    //         PATTERN IS ALWAYS WORD ALIGNED

    // RESTRICTIONS: xr>=xl
    //                 y MUST BE VALID

	int loff=(y*srf->width+xl);
	int roff=(y*srf->width+xr);
    register int *left=(int *)srf->addr+ (loff>>3);
    register int *right=(int *)srf->addr+ (roff>>3);
    int ml=ggl_leftmask(loff),mr=ggl_rightmask(roff);

    if(left==right) {
        // single word operation
        ml|=mr;
        *left=  (*left & ml) | (color & (~ml));
        return;
    }

    *left=  (*left & ml) | (color & (~ml));
    ++left;
    while(left!=right)
    {
        *left=color;
        ++left;
    }

    *right=  (*right & mr) | (color & (~mr));

}

