//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***



// $Id: sat3_createtemp.c 486 2007-10-21 21:17:04Z claudio $

#include <hpgcc3.h>
#include <master_globals.h>

SAT_OBJECT sat3_createtemp(int objsize)
{
    
    // CREATETEMP IMPLEMENTATION
    // objsize=size of object including prolog
    // in nibbles

    if(objsize<=0) return 0;
    
    SAT_OBJECT ttop=sat3_peek(SAT_TEMPTOP,5);
    SAT_OBJECT rstk=sat3_peek(SAT_RSKTOP,5);
    int size=rstk-ttop;
    int freemem;
    SAT_OBJECT ptr;

    // check for enough room here
    if(objsize>sat3_getfreetempob())
    {
    // insufficient memory to create object
    return 0;
    }


    // make room in memory
    sat3_memmove(ttop+objsize+6,ttop,size);


    // adjust tempob chain
	ptr=ttop+1+objsize;
    sat3_poke(ptr,objsize+6,5);
    
    // adjust pointers
    
    // RSKTOP
    sat3_poke(SAT_RSKTOP,sat3_peek(SAT_RSKTOP,5)+objsize+6,5);
    
    // TEMPTOP
    sat3_poke(SAT_TEMPTOP,sat3_peek(SAT_TEMPTOP,5)+objsize+6,5);
    
    // adjust free memory
    freemem=sat3_peek(SAT_DSKTOP,5)-sat3_peek(SAT_RSKTOP,5);
    freemem/=5;
    sat3_poke(SAT_AVMEM,freemem,5);
    
    // return addr to prolog of new object
    return ttop+1;

}


