//& *** (c) 2006-2011 The HPGCC3 Team ***
//& Claudio Lapilli
//& Ingo Blank
//&
//& This file is licensed under the terms and conditions of the
//& HPGCC3 license that is included with the source distribution.
//& *** (c) 2006-2011 The HPGCC3 Team ***

#include <hpgcc3.h>


#define IO_GPDDAT ((volatile unsigned int *)0x07a00034)

#define CONT_TXSTOP  0x200
#define CONT_BITREADY 0x2000
#define CONT_TX 0x1000

const unsigned short int const __lcdcontrast_table[16]={
		0x43fc,
		0x43ff,
		0x44f8,
		0x44fc,
		0x44ff,
		0x46e9,
		0x46ea,
		0x46eb,
		0x45ff,
		0x46f6,
		0x46fa,
		0x46fd,
		0x47ef,
		0x47f4,
		0x47f8,
		0x47fc
};
                                  
void __lcd_txbyte(int byte)
{
	int f;
	*IO_GPDDAT&=~CONT_TXSTOP;	// CLEAR STOP BIT
	
	byte<<=4;
	for(f=0;f<8;++f)
	{
		byte<<=1;
		*IO_GPDDAT&=~CONT_BITREADY;		// CLEAR BIT READY
		*IO_GPDDAT=((*IO_GPDDAT)&(~CONT_TX))|(byte&CONT_TX);	// SET TX BIT
		*IO_GPDDAT|=CONT_BITREADY;		// SIGNAL ONE BIT IS READY;
	}
	// NOW CLEANUP TRANSMISSION
	*IO_GPDDAT&=~ (CONT_BITREADY|CONT_TX);
	
	*IO_GPDDAT|=CONT_TXSTOP;	// SET STOP BIT
	
	
	return;
}

void lcd_setcontrast(int level)
{
	int value;
if(level>15 || level<0) level=7;

	value=__lcdcontrast_table[level];
	__lcd_txbyte((value>>8)&0xff);
	__lcd_txbyte(value&0xff);
	return;
	
}

